from AccessControl import ClassSecurityInfo
from Products.Archetypes.public import *

from config import *
from schemata import ContextActionsBaseSchema

from interfaces import IContextActionBundle
from ContextActionManager import ContextActionManager

class ContextActionBundle(BaseFolder, ContextActionManager):
    """
    A ContextActionBundle is a folder holding the ContextActions and
    ContextActionFolders belonging to one logical component, usually a
    product. By convention, ContextActionBundles are named after the
    products they belong to.
    """
    
    __implements__  = BaseFolder.__implements__ + \
                        ContextActionManager.__implements__ + \
                        (IContextActionBundle,)
    
    security        = ClassSecurityInfo()
    schema          = ContextActionsBaseSchema
    
    portal_type     = 'ContextActionBundle'
    meta_type       = 'ContextActionBundle'
    archetype_name  = 'Action bundle' 

    typeDescription = "A contextual action bundle holds the contextual " \
                      "actions belonging to one product or other logical " \
                      "component."
    typeDescMsgId   = 'description_edit_contextactionbundle'

    allow_discussion = 0 
    global_allow     = 0
    
    allowed_content_types = ['ContextActionFolder', 'ContextAction']
    
registerType(ContextActionBundle)