from AccessControl import ClassSecurityInfo
from Products.Archetypes.public import *

from config import *
from schemata import ContextActionsBaseSchema

from interfaces import IContextActionBundle
from ContextActionManager import ContextActionManager

class ContextActionFolder(BaseFolder, ContextActionManager):
    """
    A ContextActionFolder is a folder holding ContextActions and other
    ContextActionFolders belonging to a ContextActionBundle.
    """
    
    __implements__  = BaseFolder.__implements__ + \
                        ContextActionManager.__implements__ + \
                        (IContextActionBundle,)
    
    security        = ClassSecurityInfo()
    schema          = ContextActionsBaseSchema
    
    portal_type     = 'ContextActionFolder'
    meta_type       = 'ContextActionFolder'
    archetype_name  = 'Action folder' 

    typeDescription = "A contextual action folder is used to organise " \
                      "contextual actions inside a contextual action bundle."
    typeDescMsgId   = 'description_edit_contextactionbundle'

    allow_discussion = 0 
    global_allow     = 0
    
    allowed_content_types = ['ContextActionFolder', 'ContextAction']

registerType(ContextActionFolder)