from StringIO import StringIO
from Products.Archetypes import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.PloneContextActions.config import *
from Products.CMFCore.utils import getToolByName

from StringIO import StringIO

# for portlets
try:
    from Products.PlonePortlets.Extensions.utils import initializePortlet, instantiatePortlet
    from Products.PlonePortlets.Extensions.utils import registerPortlets
    havePlonePortlets = True
except ImportError:
    havePlonePortlets = False
    pass



def setupCatalogMultiplex(self, out):
    """ better than overriding all the index-methods, and more flexible too"""
    attool = getToolByName(self, 'archetype_tool')
    attool.setCatalogsByType('ContextAction', [TOOLNAME])


def install(self):
    out = StringIO()
    
    classes = listTypes(PROJECTNAME)
    installTypes(self, out, classes, PROJECTNAME)

    
    install_subskin(self, out, GLOBALS)

    print >> out, 'Successfully installed %s' % PROJECTNAME 
    
    if TOOLNAME not in self.objectIds():
        factory = self.manage_addProduct[PROJECTNAME]
        factory.manage_addTool(TOOLTYPE)
        print >> out, 'Added ' + TOOLTYPE
    else:
        print >> out, TOOLTYPE + ' already exists.'
        
    setupCatalogMultiplex(self, out)
    
    if havePlonePortlets:
        portlets = []
        for k in classes:
            if k['name']=='ActionsPortlet':
                portlets.append(k)
        registerPortlets(self, portlets)
        setupActionsPortlet(self, out)
    return out
    
def setupActionsPortlet(self, out):
    portlets_tool = getToolByName(self, 'portal_portlets')
    initializePortlet(portlets_tool, 'ContextActionsPortlet', 'contextactions', 'column2')
    
def uninstall(self):

    out = StringIO()
    
    urlTool = getToolByName(self, 'portal_url')
    portal = urlTool.getPortalObject()
    
    if TOOLNAME in portal.objectIds():
        portal.manage_delObjects([TOOLNAME])

