from Interface import Base

class IContextActionManager(Base):
    """
    Interface for classes managing collections of actions. Provides
    a clean API for adding/removing/obtaining action folders and
    actions.
    """
    
    #
    # Contained actions management
    #
    
    def getAction(id):
        """Get the ContextAction with the specified id. Raises an AttributeError
        if the action cannot be found.
        """
        pass
        
    def getAllActions():
        """Get a list of all ContextActions managed directly by this container
        """
        pass
        
    def addAction(id, title, description, categories, targetExpression, 
                    contentTypes=None, matchPath=None, 
                    states=None, templateIds=None, matchRoles=None,
                    expression=None, active=1):
        """Add a new ContextAction. All arguments without default values are
        required. Categories should be a list, as should contentTypes,
        states, templateIds and matchRoles if given. Raises an AttributeError
        if the id is already in use. Returns the newly created action.
        """
        pass
        
    def removeAction(id):
        """Remove the given ContextAction. Rasises an AttributeError if it
        cannot be found.
        """
        pass

    #
    # Contained action folders management
    #
    
    def getActionFolder(id):
        """Get the ContextActionFolder with the given id. Raises an
        AttributeError if it cannot be found.
        """
        pass
        
    def getAllActionFolders():
        """Get a list of all ActionFolders managed directly by this container.
        """
        pass
        
    def addActionFolder(id, title, description=None):
        """Add a new ContextActionFolder. Raises an AttributeError if the id is
        already in use. Returns the newly created action folder.
        """
        pass
        
    def removeActionFolder(id):
        """Remove the given ContextActionFolder. Raises an AttributeError if it
        cannot be found.
        """
        pass
