from Interface import Base

class IContextCriteriaMixin(Base):
    """
    This interfaces describes objects which can be catalogued in a catalogue
    implementing IContextCriteriaMatcher. See that interface for more details.
    """

    def getCategories():
        """Items are organised by categories. Returns a list of the categories
        this item is relevant to. At least one category will be returned.
        """
             
        pass
        
    def getContentTypes():
        """Returns the portal_type's this item is relevant to, or [] if this
        should be ignored for matching purposes.
        """
    
        pass
        
    def getMatchPath():
        """Returns a path, relative to the portal root, of the portal section
        this item is relevant to, or an empty string if this should be ignored
        for matching purposes.
        """
    
        pass
        
    def getStates():
        """Return a list of workflow state names this item is relevant to, or
        [] if this should be ignored for matching purposes.
        """
    
        pass
        
    def getTemplateIds():
        """Return a list of template ids this item is relevant to, or [] if
        this should be ignored for matching purposes.
        """
    
        pass
    
    def getMatchRoles():
        """Return a list of user ids this item is relevant to, or [] if
        this should be ignored for matching purposes.
        """
    
        pass
        
    def getExpression():
        """Return a TALES expression which should be evaluated during matching.
        Only if this expression evaluates to true should the item be considered
        a match. May return an empty string if no expression is set, in which
        case it should be ignored for matching purposes.
        """
    
        pass
        
    def isActive():
        """Returns a boolean value. Only items with isActive() returning true
        should be considered a match. Items with isActive() returning false
        should be ignored entirely for matching purposes.
        """
    
        pass
