
import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase

from Products.PloneContextActions.tests import catc
from Products.PloneContextActions.config import *
from Products.CMFCore.utils import getToolByName

from Products.PlonePortlets.Extensions.utils import initializePortlet, instantiatePortlet


class TestPortlet(catc.ContextActionsTestCase):

    def afterSetUp(self):
        self.setRoles(['Manager'])
        self.tool = self.portal.portal_contextactions
        self.bundle = self.tool.addBundle('t1', 'Test bundle 1')
        self.portlets_tool = getToolByName(self.portal, 'portal_portlets', None)
        
    def testPortletToolInstalled(self):
        self.failUnless(self.portlets_tool)
        
    def testPortletAdded(self):
        self.failUnless(hasattr(self.portlets_tool, 'contextactions'))
        self.failUnless('contextactions' in self.portlets_tool.objectIds())

    def testPortletAddedToSection(self):
        self.failUnless('contextactions' in [i.getId for i in self.portlets_tool.getPortletsSection(self.portal,'column2')])
        
    def testShowingActionsInPortlet(self):
        p = self.portlets_tool.contextactions        
        self.failIf(p._fetchPortletData())
        self.bundle.invokeFactory('ContextAction', 'TestAction') 
        self.failUnless(p._fetchPortletData())
      
      
class TestPortletQueries(catc.ContextActionsTestCase):
    
    def afterSetUp(self):
        self.setRoles(['Manager'])
        self.tool = self.portal.portal_contextactions
        self.bundle = self.tool.addBundle('t1', 'Test bundle 1')
        self.portlets_tool = getToolByName(self.portal, 'portal_portlets', None)
        
        for i in self.portal.portal_portlets.wrapAndFilterSection(self.folder, 'column2'):
            if i.getId() == 'contextactions':
                portlet = i
        self.portlet = portlet
    
          
    def testActionsInPortletWithCriteria(self):
        self.failIf( self.portlet._fetchPortletData())
        self.bundle.invokeFactory('ContextAction', 'TestAction')
        a = self.bundle.TestAction
        a.setContentTypes(['Document'])
        a.reindexObject()  
        self.assertEqual(len(self.portlet._fetchPortletData()),0)
        a.setContentTypes([]) 
        a.reindexObject()  
        self.assertEqual(len(self.portlet._fetchPortletData()),1)
        a.setContentTypes(['Folder'])
        a.reindexObject()  
        self.assertEqual(len(self.portlet._fetchPortletData()),1)
        

def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestPortlet))
    suite.addTest(makeSuite(TestPortletQueries))
    return suite

if __name__ == '__main__':
    framework()
