from AccessControl import ClassSecurityInfo
from Products.Archetypes.public import *

from config import *
from schemata import ContextHelpBaseSchema

from interfaces import IContextHelpBundle
from ContextHelpManager import ContextHelpManager

class ContextHelpBundle(BaseFolder, ContextHelpManager):
    """
    A ContextHelpBundle is a folder holding the ContextHelpPages and
    ContextHelpFolders belonging to one logical component, usually a
    product. By convention, ContextHelpBundles are named after the
    products they belong to.
    """
    
    __implements__  = BaseFolder.__implements__ + \
                        ContextHelpManager.__implements__ + \
                        (IContextHelpBundle,)
    
    security        = ClassSecurityInfo()
    schema          = ContextHelpBaseSchema
    
    portal_type     = 'ContextHelpBundle'
    meta_type       = 'ContextHelpBundle'
    archetype_name  = 'Help bundle' 

    typeDescription = "A contextual help bundle holds the contextual " \
                      "help pages belonging to one product or other logical " \
                      "component."
    typeDescMsgId   = 'description_edit_contexthelpbundle'

    allow_discussion = 0 
    global_allow     = 0
    
    allowed_content_types = ['ContextHelpFolder', 'ContextHelpPage']
    
    _at_rename_after_creation = True
    
registerType(ContextHelpBundle)