from AccessControl import ClassSecurityInfo
from Products.Archetypes.public import *

from config import *
from schemata import ContextHelpBaseSchema

from interfaces import IContextHelpBundle
from ContextHelpManager import ContextHelpManager

class ContextHelpFolder(BaseFolder, ContextHelpManager):
    """
    A ContextHelpFolder is a folder holding ContextHelpPages and other
    ContextHelpFolders belonging to a ContextHelpBundle.
    """
    
    __implements__  = BaseFolder.__implements__ + \
                        ContextHelpManager.__implements__ + \
                        (IContextHelpBundle,)
    
    security        = ClassSecurityInfo()
    schema          = ContextHelpBaseSchema
    
    portal_type     = 'ContextHelpFolder'
    meta_type       = 'ContextHelpFolder'
    archetype_name  = 'Help folder' 

    typeDescription = "A contextual help folder is used to organise " \
                      "contextual help pages inside a contextual help bundle."
    typeDescMsgId   = 'description_edit_contexthelpbundle'

    allow_discussion = 0 
    global_allow     = 0
    
    allowed_content_types = ['ContextHelpFolder', 'ContextHelpPage']

    _at_rename_after_creation = True

registerType(ContextHelpFolder)