from AccessControl import ClassSecurityInfo
from Products.Archetypes.public import *

from Acquisition import aq_parent, aq_base, aq_inner

from config import *
from Products.CMFCore.utils import getToolByName
from Products.CMFCore import CMFCorePermissions

from Products.CMFCore.Expression import Expression
from Products.CMFCore.Expression import createExprContext

from Products.PloneContextActions.ContextCriteriaMixin import \
    ContextCriteriaMixin

from interfaces import IContextHelpPage

import schemata

class ContextHelpPage(BaseContent, ContextCriteriaMixin):
    """
    A ContextHelp represents a context-dependent Help. The
    criteria found in the mixin class ContextCriteriaMixin are used
    by ContextHelpsTool to determine whether or not a given Help
    should be offered in the current context.
    """
    
    __implements__  = BaseContent.__implements__ + \
                      ContextCriteriaMixin.__implements__ + \
                      (IContextHelpPage,)
    
    security        = ClassSecurityInfo()
    schema          = schemata.ContextHelpPageSchema
    
    portal_type     = 'ContextHelpPage'
    meta_type       = 'ContextHelpPage'
    archetype_name  = 'Help page' 

    allow_discussion = 0 
    global_allow     = 0
    allowed_content_types = ['Image', 'ATImage']
    
    _at_rename_after_creation = True
          
    # Implement "abstract" method from ContextCriteriaMixin
    def getExistingCategories(self):
        """
        Get a DisplayList of categories currently in use. Used as the vocabulary
        for the categories field.
        """
        tool = getToolByName(self, 'portal_contexthelp')
        
        lst = DisplayList()
        
        for category in tool.getAvailableCategories():
            lst.add(category, category)
            
        return lst.sortedByValue()


registerType(ContextHelpPage)
