from StringIO import StringIO
from Products.Archetypes import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.PloneContextHelp.config import *
from Products.CMFCore.utils import getToolByName

from StringIO import StringIO

def setupCatalogMultiplex(self, out, portalType, catalogs=[TOOLNAME, 'portal_catalog']):
    """Add the type to the portal_contexthelp catalog"""
    attool = getToolByName(self, 'archetype_tool')
    attool.setCatalogsByType(portalType, catalogs)
    print >> out, "Added %s to catalogs %s" % (portalType, catalogs)

def setTypeNotSearched(self, out, portalType='ContextHelpPage'):
    """Add the given type to the types_not_searched list"""
    portalProperties = getToolByName(self, 'portal_properties')
    siteProperties = getattr(portalProperties, 'site_properties')
    typesNotSearched = list(getattr(siteProperties, 'types_not_searched'))
    if portalType in typesNotSearched:
        print >> out, "%s already in types_not_searched" % (portalType,)
    else:
        typesNotSearched.append(portalType)
        setattr(siteProperties, 'types_not_searched', tuple(typesNotSearched))

def installPortlet(self, out, portletPath, slots='right_slots'):
    """Install the given portlet at the portal root"""
    portalRoot = getToolByName(self, 'portal_url').getPortalObject()
    installedPortlets = list(getattr(portalRoot, slots))
    if portletPath in installedPortlets:
        print >> out, '%s is already installed in %s' % (portletPath, slots)
    else:
        installedPortlets.append(portletPath)
        setattr(portalRoot, slots, tuple(installedPortlets))
        print >> out, 'Installed %s in %s' % (portletPath, slots)

def uninstallPortlet(self, out, portletPath, slots='right_slots'):
    """Uninstall the given portlet from the portal root"""
    portalRoot = getToolByName(self, 'portal_url').getPortalObject()
    installedPortlets = list(getattr(portalRoot, slots))
    if portletPath not in installedPortlets:
        print >> out, '%s is not installed in %s' % (portletPath, slots)
    else:
        installedPortlets.remove(portletPath)
        setattr(portalRoot, slots, tuple(installedPortlets))
        print >> out, 'Uninstalled %s from %s' % (portletPath, slots)


def install(self):
    out = StringIO()

    classes = listTypes(PROJECTNAME)
    installTypes(self, out, classes, PROJECTNAME)

    install_subskin(self, out, GLOBALS)

    print >> out, 'Successfully installed %s' % PROJECTNAME

    if TOOLNAME not in self.objectIds():
        factory = self.manage_addProduct[PROJECTNAME]
        factory.manage_addTool(TOOLTYPE)
        out.write('Added ' + TOOLTYPE )
        print >> out, 'Added ' + TOOLTYPE
    else:
        print >> out, TOOLTYPE + ' already exists.'

    setupCatalogMultiplex(self, out, 'ContextHelpPage')
    setTypeNotSearched(self, out, 'ContextHelpPage')
    installPortlet(self, out, 'here/portlet_contexthelp/macros/portlet')

    return out.getvalue()

def uninstall(self):

    out = StringIO()

    urlTool = getToolByName(self, 'portal_url')
    portal = urlTool.getPortalObject()

    if TOOLNAME in portal.objectIds():
        portal.manage_delObjects([TOOLNAME])

    uninstallPortlet(self, out, 'here/portlet_contexthelp/macros/portlet')

    return out.getvalue()

