from Interface import Base

class IContextHelpManager(Base):
    """
    Interface for classes managing collections of help pages. Provides
    a clean API for adding/removing/obtaining help folders and pages.
    """
    
    #
    # Contained help pages management
    #
    
    def getHelpPage(id):
        """Get the ContextHelpPage with the specified id. Raises an 
        AttributeError if the Help cannot be found.
        """
        pass
        
    def getAllHelpPages():
        """Get a list of all ContextHelpPages managed directly by this 
        container.
        """
        pass
        
    def addHelpPage(id, title, description, body, mimetype, categories, 
                    contentTypes=None, path=None, 
                    states=None, templateIds=None, matchRoles=None,
                    expression=None, active=1, related=None):
        """Add a new ContextHelpPage. All arguments without default values are
        required. Categories should be a list, as should contentTypes,
        states, templateIds, matchRoles and related if given. Raises an 
        AttributeError if the id is already in use. Returns the newly created 
        help page.
        """
        pass
        
    def removeHelpPage(id):
        """Remove the given ContextHelpPage. Rasises an AttributeError if it
        cannot be found.
        """
        pass

    #
    # Contained Help folders management
    #
    
    def getHelpFolder(id):
        """Get the ContextHelpFolder with the given id. Raises an
        AttributeError if it cannot be found.
        """
        pass
        
    def getAllHelpFolders():
        """Get a list of all HelpFolders managed directly by this container.
        """
        pass
        
    def addHelpFolder(id, title, description=None):
        """Add a new ContextHelpFolder. Raises an AttributeError if the id is
        already in use. Returns the newly created Help folder.
        """
        pass
        
    def removeHelpFolder(id):
        """Remove the given ContextHelpFolder. Raises an AttributeError if it
        cannot be found.
        """
        pass