## Script (Python) "getRelevantHelpPages"
##title=Get the help pages from portal_contexthelp, as a list of {'name' : categoryName, 'pages' : [page1, page2]} dicts
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=template=None, categories=None

from Products.CMFCore.utils import getToolByName
contextHelpTool = getToolByName(context, 'portal_contexthelp', None)

if contextHelpTool is None:
    return None

if template is not None:
    templateId = template.getId()
else:
    templateId = None

results = contextHelpTool.getHelp(context, templateId, categories)

matchedCategories = {}

for r in results:
    for c in r.getCategories:
        if c not in matchedCategories:
            matchedCategories[c] = [r]
        else:
            matchedCategories[c].append(r)

categories = [{'name' : c, 'pages' : []} for c in matchedCategories.keys()]
for item in categories:
    pages = matchedCategories[item['name']]
    pages.sort(lambda x, y: cmp(x.Title, y.Title))
    item['pages'] = pages

return categories